com.fasterxml.jackson.databind.deser.std

## Class StdDelegatingDeserializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdDelegatingDeserializer<T>

Type Parameters:
  `T` - Target type to convert to, from delegate type

All Implemented Interfaces:
  ContextualDeserializer, NullValueProvider, ResolvableDeserializer, ValueInstantiator.Gettable, Serializable

    public class StdDelegatingDeserializer<T>
    extends StdDeserializer<T>
    implements ContextualDeserializer, ResolvableDeserializer

Deserializer implementation where given Java type is first deserialized by a standard Jackson deserializer into a delegate type; and then this delegate type is converted using a configured `Converter` into desired target type. Common delegate types to use are `Map` and `JsonNode`.

Note that although types (delegate, target) may be related, they must not be same; trying to do this will result in an exception.

Since 2.5 There is `StdNodeBasedDeserializer` that is a simplified version for cases where intermediate type is `JsonNode`

NOTE: in Jackson 3.0 this class will be renamed as `StdConvertingDeserializer`.

Since:
  2.1
See Also:
  `StdNodeBasedDeserializer`, `Converter`, Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected Converter<Object,T>` `_converter` Converter that was used for creating `_delegateDeserializer`.
`protected JsonDeserializer<Object>` `_delegateDeserializer` Underlying serializer for type `T`.
`protected JavaType` `_delegateType` Fully resolved delegate type, with generic information if any available.

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`` `StdDelegatingDeserializer(Converter<?,T> converter)`
`` `StdDelegatingDeserializer(Converter<Object,T> converter, JavaType delegateType, JsonDeserializer<?> delegateDeserializer)`
`protected` `StdDelegatingDeserializer(StdDelegatingDeserializer<T> src)`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`protected T` `_convertIfNonNull(Object delegateValue)`
`protected Object` `_handleIncompatibleUpdateValue(JsonParser p, DeserializationContext ctxt, Object intoValue)` Overridable handler method called when `deserialize(JsonParser, DeserializationContext, Object)` has been called with a value that is not compatible with delegate value.
`protected T` `convertValue(DeserializationContext ctxt, Object delegateValue)` Method called to convert from "delegate value" (which was deserialized from JSON using standard Jackson deserializer for delegate type) into desired target type.
`protected T` `convertValue(Object delegateValue)` Deprecated. since 2.19 Call `convertValue(DeserializationContext, Object)`
`JsonDeserializer<?>` `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
`T` `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`T` `deserialize(JsonParser p, DeserializationContext ctxt, Object intoValue)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
`Object` `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
`Object` `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer, T intoValue)` Method similar to `JsonDeserializer.deserializeWithType(JsonParser,DeserializationContext,TypeDeserializer)` but called when merging value.
`Object` `getAbsentValue(DeserializationContext ctxt)` Method called to determine placeholder value to be used for cases where no value was obtained from input but we must pass a value nonetheless: the common case is that of Creator methods requiring passing a value for every parameter.
`JsonDeserializer<?>` `getDelegatee()` Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls.
`AccessPattern` `getEmptyAccessPattern()` This method may be called in conjunction with calls to `JsonDeserializer.getEmptyValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.
`Object` `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
`Collection<Object>` `getKnownPropertyNames()` Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name.
`AccessPattern` `getNullAccessPattern()` This method may be called in conjunction with calls to `JsonDeserializer.getNullValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.
`T` `getNullValue(DeserializationContext ctxt)` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
`Class<?>` `handledType()` Method for accessing concrete physical type of values this deserializer produces.
`boolean` `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
`LogicalType` `logicalType()` Method for accessing logical type of values this deserializer produces.
`JsonDeserializer<T>` `replaceDelegatee(JsonDeserializer<?> delegatee)` Method that can be called to try to replace deserializer this deserializer delegates calls to.
`void` `resolve(DeserializationContext ctxt)` Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller.
`Boolean` `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.
`JsonDeserializer<T>` `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.
`protected StdDelegatingDeserializer<T>` `withDelegate(Converter<Object,T> converter, JavaType delegateType, JsonDeserializer<?> delegateDeserializer)` Method used for creating resolved contextual instances.

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _checkBooleanToStringCoercion, _checkCoercionFail, _checkDoubleSpecialValue, _checkFloatSpecialValue, _checkFloatToIntCoercion, _checkFloatToStringCoercion, _checkFromStringCoercion, _checkFromStringCoercion, _checkIntToFloatCoercion, _checkIntToStringCoercion, _checkTextualNull, _checkToStringCoercion, _coerceBooleanFromInt, _coercedTypeDesc, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeFromEmptyString, _deserializeFromString, _deserializeWrappedValue, _failDoubleToIntCoercion, _findCoercionFromBlankString, _findCoercionFromEmptyArray, _findCoercionFromEmptyString, _findNullProvider, _hasTextualNull, _intOverflow, _isBlank, _isEmptyOrTextualNull, _isFalse, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _isTrue, _neitherNull, _nonNullNumber, _parseBoolean, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDouble, _parseDouble, _parseDoublePrimitive, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseInteger, _parseInteger, _parseInteger, _parseIntPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLong, _parseLong, _parseLong, _parseLongPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _parseString, _reportFailedNullCoerce, _shortOverflow, _streamReadConstraints, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueInstantiator, getValueType, getValueType, handleMissingEndArrayForSingle, handleNestedArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`findBackReference, getEmptyValue, getNullValue, getObjectIdReader`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _converter

    protected final Converter<Object,T> _converter

Converter that was used for creating `_delegateDeserializer`.

#### _delegateType

    protected final JavaType _delegateType

Fully resolved delegate type, with generic information if any available.

#### _delegateDeserializer

    protected final JsonDeserializer<Object> _delegateDeserializer

Underlying serializer for type `T`.

### Constructor Detail

#### StdDelegatingDeserializer

    public StdDelegatingDeserializer(Converter<?,T> converter)

#### StdDelegatingDeserializer

    public StdDelegatingDeserializer(Converter<Object,T> converter,
                                     JavaType delegateType,
                                     JsonDeserializer<?> delegateDeserializer)

#### StdDelegatingDeserializer

    protected StdDelegatingDeserializer(StdDelegatingDeserializer<T> src)

Since:
  2.5

### Method Detail

#### withDelegate

    protected StdDelegatingDeserializer<T> withDelegate(Converter<Object,T> converter,
                                                        JavaType delegateType,
                                                        JsonDeserializer<?> delegateDeserializer)

Method used for creating resolved contextual instances. Must be overridden when sub-classing.

#### unwrappingDeserializer

    public JsonDeserializer<T> unwrappingDeserializer(NameTransformer unwrapper)

Description copied from class: `JsonDeserializer`
Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

Default implementation just returns 'this' indicating that no unwrapped variant exists

Overrides:
  `unwrappingDeserializer` in class `JsonDeserializer<T>`

#### replaceDelegatee

    public JsonDeserializer<T> replaceDelegatee(JsonDeserializer<?> delegatee)

Description copied from class: `JsonDeserializer`
Method that can be called to try to replace deserializer this deserializer delegates calls to. If not supported (either this deserializer does not delegate anything; or it does not want any changes), should either throw `UnsupportedOperationException` (if operation does not make sense or is not allowed); or return this deserializer as is.

Overrides:
  `replaceDelegatee` in class `JsonDeserializer<T>`

#### resolve

    public void resolve(DeserializationContext ctxt)
                 throws JsonMappingException

Description copied from interface: `ResolvableDeserializer`
Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller. Called object can then resolve its dependencies to other types, including self-references (direct or indirect).

Specified by:
  `resolve` in interface `ResolvableDeserializer`
Parameters:
  `ctxt` - Context to use for accessing configuration, resolving secondary deserializers
Throws:
  `JsonMappingException`

#### createContextual

    public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                BeanProperty property)
                                         throws JsonMappingException

Description copied from interface: `ContextualDeserializer`
Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualDeserializer`
Parameters:
  `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
  `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
Returns:
  Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException` - If there is problem with contextualization

#### deserialize

    public T deserialize(JsonParser p,
                         DeserializationContext ctxt)
                  throws IOException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (p.currentToken() == JsonToken.START_OBJECT) {
             p.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Handling null values (JsonToken.VALUE_NULL)
: Note that this method is never called for the JSON `null` literal to avoid every deserializer from having to handle null values. Instead, the `JsonDeserializer.getNullValue(DeserializationContext)` method is called to produce a null value. To influence null handling, custom deserializers should override `JsonDeserializer.getNullValue(DeserializationContext)` and usually also `JsonDeserializer.getNullAccessPattern()`.

Specified by:
  `deserialize` in class `JsonDeserializer<T>`
Parameters:
  `p` - Parser used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser p,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException

Description copied from class: `StdDeserializer`
Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

Overrides:
  `deserializeWithType` in class `StdDeserializer<T>`
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`

#### deserialize

    public T deserialize(JsonParser p,
                         DeserializationContext ctxt,
                         Object intoValue)
                  throws IOException

Description copied from class: `JsonDeserializer`
Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

Overrides:
  `deserialize` in class `JsonDeserializer<T>`
Throws:
  `IOException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser p,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer,
                                      T intoValue)
                               throws IOException,
                                      JacksonException

Description copied from class: `JsonDeserializer`
Method similar to `JsonDeserializer.deserializeWithType(JsonParser,DeserializationContext,TypeDeserializer)` but called when merging value. Considered "bad merge" by default implementation, but if `MapperFeature.IGNORE_MERGE_FOR_UNMERGEABLE` is enabled will simple delegate to `JsonDeserializer.deserializeWithType(JsonParser, DeserializationContext, TypeDeserializer)`.

Overrides:
  `deserializeWithType` in class `JsonDeserializer<T>`
Throws:
  `IOException`
  `JacksonException`

#### _handleIncompatibleUpdateValue

    protected Object _handleIncompatibleUpdateValue(JsonParser p,
                                                    DeserializationContext ctxt,
                                                    Object intoValue)
                                             throws IOException

Overridable handler method called when `deserialize(JsonParser, DeserializationContext, Object)` has been called with a value that is not compatible with delegate value. Since no conversion are expected for such "updateValue" case, this is normally not an operation that can be permitted, and the default behavior is to throw exception. Sub-classes may choose to try alternative approach if they have more information on exact usage and constraints.

Throws:
  `IOException`
Since:
  2.6

#### handledType

    public Class<?> handledType()

Description copied from class: `JsonDeserializer`
Method for accessing concrete physical type of values this deserializer produces. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

Default implementation will return null, which means almost same same as returning `Object.class` would; that is, that nothing is known about handled type.

Overrides:
  `handledType` in class `StdDeserializer<T>`
Returns:
  Physical type of values this deserializer produces, if known; `null` if not

#### logicalType

    public LogicalType logicalType()

Description copied from class: `JsonDeserializer`
Method for accessing logical type of values this deserializer produces. Typically used for further configuring handling of values, for example, to find which coercions are legal.

Overrides:
  `logicalType` in class `JsonDeserializer<T>`
Returns:
  Logical type of values this deserializer produces, if known; `null` if not

#### isCachable

    public boolean isCachable()

Description copied from class: `JsonDeserializer`
Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

Default implementation returns false, to indicate that no caching is done.

Overrides:
  `isCachable` in class `JsonDeserializer<T>`

#### getDelegatee

    public JsonDeserializer<?> getDelegatee()

Description copied from class: `JsonDeserializer`
Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls. If so, will return immediate delegate (which itself may delegate to further deserializers); otherwise will return null.

Overrides:
  `getDelegatee` in class `JsonDeserializer<T>`
Returns:
  Deserializer this deserializer delegates calls to, if null; null otherwise.

#### getKnownPropertyNames

    public Collection<Object> getKnownPropertyNames()

Description copied from class: `JsonDeserializer`
Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name. This is only to be used for error reporting and diagnostics purposes (most commonly, to accompany "unknown property" exception).

Overrides:
  `getKnownPropertyNames` in class `JsonDeserializer<T>`

#### getNullValue

    public T getNullValue(DeserializationContext ctxt)
                   throws JsonMappingException

Description copied from class: `JsonDeserializer`
Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

This method may be called once, or multiple times, depending on what `JsonDeserializer.getNullAccessPattern()` returns.

Default implementation simply returns null.

Specified by:
  `getNullValue` in interface `NullValueProvider`
Overrides:
  `getNullValue` in class `JsonDeserializer<T>`
Throws:
  `JsonMappingException`

#### getNullAccessPattern

    public AccessPattern getNullAccessPattern()

Description copied from class: `JsonDeserializer`
This method may be called in conjunction with calls to `JsonDeserializer.getNullValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.

Default implementation indicates that the "null value" to use for input null does not vary across uses so that `JsonDeserializer.getNullValue(DeserializationContext)` need not be called more than once per deserializer instance. This information may be used as optimization.

Specified by:
  `getNullAccessPattern` in interface `NullValueProvider`
Overrides:
  `getNullAccessPattern` in class `JsonDeserializer<T>`

#### getAbsentValue

    public Object getAbsentValue(DeserializationContext ctxt)
                          throws JsonMappingException

Description copied from class: `JsonDeserializer`
Method called to determine placeholder value to be used for cases where no value was obtained from input but we must pass a value nonetheless: the common case is that of Creator methods requiring passing a value for every parameter. Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java `null`), but it can be overridden for specific types: most notable scalar types must use "default" values.

This method needs to be called every time a determination is made.

Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Specified by:
  `getAbsentValue` in interface `NullValueProvider`
Overrides:
  `getAbsentValue` in class `JsonDeserializer<T>`
Throws:
  `JsonMappingException`

#### getEmptyValue

    public Object getEmptyValue(DeserializationContext ctxt)
                         throws JsonMappingException

Description copied from class: `JsonDeserializer`
Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for specific types. Or, if type should never be converted from empty String, method can also throw an exception.

This method may be called once, or multiple times, depending on what `JsonDeserializer.getEmptyAccessPattern()` returns.

Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Overrides:
  `getEmptyValue` in class `JsonDeserializer<T>`
Throws:
  `JsonMappingException`

#### getEmptyAccessPattern

    public AccessPattern getEmptyAccessPattern()

Description copied from class: `JsonDeserializer`
This method may be called in conjunction with calls to `JsonDeserializer.getEmptyValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.

Overrides:
  `getEmptyAccessPattern` in class `JsonDeserializer<T>`

#### supportsUpdate

    public Boolean supportsUpdate(DeserializationConfig config)

Description copied from class: `JsonDeserializer`
Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserializer construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

Default implementation returns `null` to allow explicit per-type or per-property attempts.

Overrides:
  `supportsUpdate` in class `JsonDeserializer<T>`

#### convertValue

    @Deprecated
    protected T convertValue(Object delegateValue)

Deprecated. since 2.19 Call `convertValue(DeserializationContext, Object)`
Method called to convert from "delegate value" (which was deserialized from JSON using standard Jackson deserializer for delegate type) into desired target type.

The default implementation uses configured `Converter` to do conversion.

Parameters:
  `delegateValue` -
Returns:
  Result of conversion

#### convertValue

    protected T convertValue(DeserializationContext ctxt,
                             Object delegateValue)

Method called to convert from "delegate value" (which was deserialized from JSON using standard Jackson deserializer for delegate type) into desired target type.

The default implementation uses configured `Converter` to do conversion.

Parameters:
  `ctxt` - Context for deserialization (needed for some conversions)
  `delegateValue` - Value delegated
Returns:
  Result of conversion
Since:
  2.19

#### _convertIfNonNull

    protected T _convertIfNonNull(Object delegateValue)